(function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
var categories = { 
		wound: {
		    category: 1,
			muted_color : '#ff9999',
		    bright_color: '#cc3300',
		    polygonFill: true,
		},
		negative: {
		    category: 2,
			muted_color : '#b48acd',
		    bright_color: '#502b62',
		    polygonFill: true,
		},
		sticker: {
		    category : 3,
			muted_color : '#b4cd8a',
		    bright_color : '#50622b',
		    polygonFill: true,
		},
		save: {
		    category: 4,
			muted_color : '#ac2925',
		    bright_color: '#c9302c',
		    polygonFill: true,
		},
		under: {
		    category: 5,
			muted_color : '#cdb48a',
		    bright_color: '#62502b',
		    polygonFill: true,
		},
		freestyle: {
		    category: 6,
			muted_color : '#EEE',
		    bright_color: '#EEE',
		    polygonFill: false,
		}
	};

// define for Node module pattern loaders, including Browserify
if (typeof module === 'object' && 
    typeof module.exports === 'object') {
    module.exports = categories;
}
},{}],2:[function(require,module,exports){
var map = require('./leaflet-map');

(function () {
	for (var i = 0, len = arguments.length; i < len; i++) {
		(function ($elem) {
			$elem.on('change', 'input', function () {
				$elem.find('input')
					.next()
					.removeClass('active');

				$elem.find('input:checked')
					.next()
					.addClass('active');
			});
		})(arguments[i]);
	}
})($('#draw-tools'), $('#draw-colors'));
},{"./leaflet-map":4}],3:[function(require,module,exports){
var map = require('./leaflet-map'),
	categories = require('./categories'),
	group = new L.LayerGroup(),
	activetool = $('#draw-tools').find('input:checked').val(),
	activetype = $('#draw-colors').find('input:checked').val(),
	turfwebworker = new Worker('../js/turf-web-worker.min.js'),
	region = require('./region'),
	regioncache,
	freestyleGroup = new L.LayerGroup();

region.on('add', function () {
	regioncache = turf.buffer(region.toGeoJSON(), 0.000001);
});

window.drawer = [];
window.freestyleOn = false;
var verbose = false;					//Usually false



//Handle normal polygon layers
for (var name in categories) {
	var obj = categories[name];



	//Polygons
	var drawer = new L.FreeHandShapes({
		polygon : {
			color : obj.muted_color,
			fillColor : obj.bright_color,
			weight:3,
			smoothFactor: 0.01		//Was 1 before AJ
		},
		polyline : {
			color: obj.bright_color,
			smoothFactor: 0
		},
		polygonFill : obj.polygonFill
	});


	drawer.category = name;

	group.addLayer( drawer );

	window.group = group;		//Set global
	window.drawer.push(drawer);	//Make each drawer global
	
		

		
		



	
	drawer.on('layeradd', function (data) {
		var poly = data.layer;
		
		console.log('layeradd');
		
		
		
		intersectWithStudyArea( poly );
	});

	drawer.on('layersubtract', subtractOtherLayers);
}

//Add preexisting layers AJ
setTimeout(function() {
	if(window.polygons) {
		activeTool = "add";
		
		for(let layer of window.polygons) {
			 if(layer.loadedPolygons && layer.loadedPolygons == true) {
				for(var cnt=0 ; cnt< window.drawer.length; cnt++) {
					if(window.drawer[cnt].category === layer.category) {
						activeType = layer.category;
						//Set initial colours
						
						
						window.drawer[cnt].addLayer(layer); 		
					}
				}
			 }
		}

	}
}, 500);



function intersectWithStudyArea (polya) {

	turfwebworker.postMessage({
		_leaflet_id : polya._leaflet_id,
		primary : polya.toGeoJSON(),
		mode : 'intersect',
		secondary : regioncache,
	});

}

function subtractOtherLayers (data) {
	var polyb = data.layer.toGeoJSON();

	// collect polygons
	group.eachLayer(function (layer) {
		if (layer === this) return;

		layer.eachLayer(function (polya) {
			// difference each layer
			turfwebworker.postMessage({
				_leaflet_id : polya._leaflet_id,
				primary : polya.toGeoJSON(),
				mode : 'difference',
				secondary : polyb,
			});
		});
	}, this);
}

// listen to worker
turfwebworker.addEventListener('message', function (e) {
	var data = e.data,
		geojson = data.geojson, // or false
		geometry = geojson ? geojson.geometry : null,
		_leaflet_id = data._leaflet_id,
		_layer = map._layers[ _leaflet_id ],
		coords,
		group;

	if (_layer)	 {
		if (!geometry) {
			// removed
			_layer.destroy();
		} else if (geometry.type === "Polygon") {
			// my word, it worked
			_layer.setLatLngs( geometry.coordinates );
		} else if (geometry.type === "MultiPolygon") {
			group = _layer.getGroup();
			coords = geometry.coordinates;

			// destroy and make new singles from the multi
			_layer.destroy();

			for (var i = 0, len = coords.length; i < len; i++) {
				var newpoly = coords[i];
				// no simplify, no merge, no event
				group.addPolygon(newpoly, true, true, true);
				
			}
		}
	}
});

group.addTo(map);

group.getAllAsJSON = function () {
	/*
	returns as defined in simulator's LandUsePlanShapesView
		output = {
          category : (multi) geojson, 
          ...
        }
	*/
	var output = {};

	group.eachLayer(function(layer) {
		if(layer.getLayers) {
			var polygons = layer.getLayers();
		} else {
			var polygons = [];
		}
		
		var coords = polygons.map(function (poly) {
				return poly.toGeoJSON().geometry.coordinates;
			});
		
		if (!coords.length) return;

		output[ layer.category ] = turf.multiPolygon(coords); 
	});

	return output;
};

group.getAllAsPolygons = function () {
	/*
	a debug convenience 

	returns
		{
          category : polygons, 
          ...
        }
	*/
	var output = {};

	group.eachLayer(function(layer) {
		var polygons = layer.getLayers() || [];
			
		if (!polygons.length) return;

		output[ layer.category ] = polygons; 
	});

	return output;
};

group.enablePanTool = function () {
	this.eachLayer(function (layer) {
		layer.setMode('view');
	});
};

group.enableAddTool = function () {

	this.eachLayer(function (layer) {
		if (layer.category === activetype) {
			// enable drawing tool for type
			layer.setMode('add');
			
			if(activetype == 'freestyle') {
				window.freestyleOn = true;
			} else {
				window.freestyleOn = false;
			}
		} else {
			// disables other freehand instances
			layer.setMode('view');
		}
	});
	$(map._container).addClass('leaflet-fhs-add');
};

group.enableSubtractTool = function () {

	this.eachLayer(function (layer) {
		if (layer.category === activetype) {
			// enable drawing tool for type
			layer.setMode('subtract');
		} else {
			// disables other freehand instances
			layer.setMode('view');
		}
	});
	$(map._container).addClass('leaflet-fhs-subtract');
};

group.enableDeleteTool = function () {
	this.eachLayer(function (layer) {
		if (layer.category === activetype) {
			// enable drawing tool for type
			layer.setMode('delete');
		} else {
			// disables other freehand instances
			layer.setMode('view');
		}
	});
	$(map._container).addClass('leaflet-fhs-delete');
};



group.convertLatLngToPixels = function(lat, lng, coords) {
	var x = Math.round((lng + coords.MAP_LNG_RANGE/2) * coords.ratioX);
	var y = Math.round((lat + coords.MAP_LAT_RANGE/2) * coords.ratioY);

	return [x, y];
}


group.saveData = function(theseAreas) {

	//Save facility - taken from photo-analysis.html originally.
	jQuery('#save-drawing-title').html("Saving ..");
	$('#tool-message').html("Saving ..");

	//var points = JSON.stringify(outputPoints);
	var points =[];

	var arrayA = Array.from(theseAreas.woundAreas);
	var arrayB = Array.from(theseAreas.stickerAreas);
	var arrayC = Array.from(theseAreas.underAreas);
	var arrayD = Array.from(theseAreas.negativeAreas);
	var arrayE = Array.from(theseAreas.freestyleAreas);
	var areas = arrayA.concat(arrayB, arrayC, arrayD, arrayE);		//Append the five arrays together


	if((!areas)||(!areas[0])||(!areas[0].points)) {
	
		var areasStr = "[]";
	} else {
	
		var areasStr = JSON.stringify(areas);
	}
	
	if(verbose && verbose == true) {
		alert("Saving final areas:" + areasStr);
	
	}

	
	var woundData = {
		 "colourType": null,
		 "id" : null,
		 "scope" : "photo",
		 "photo" : "/" + customImage,
		 "act": "drawing",
		 "areas": areasStr,
		 "width": coords.IMAGE_WIDTH,
		 "height": coords.IMAGE_HEIGHT
	}



	//var uri = "/addon/fine-tune/";			//old way but limited to size on Windows servers
	var uri = "/addon/fine-large-tune/";


   jQuery.ajax({
		url: uri,
		data: woundData,
		type: "POST",	
		contentType: "application/json; charset=utf-8",
  		dataType: "json",
		success: function(data) {
			var myobj = data;
			
			if(myobj.completed == true) {
				jQuery('#save-drawing-title').html("Save");
				$('#tool-message').html("Saved");
				jQuery('#total-area').html(myobj.area);
				if(myobj.underArea) {
					jQuery('#undermine-area').html(myobj.underArea);
				} else {
					jQuery('#undermine-area').html("");
				}
				
				
				//OK - completed fine, now rewrite the thumbnail in the background
				var refreshData = {
					 "colourType": null,
					 "id" : null,
					 "scope" : "photo",
					 "photo" : "/" + customImage,
					 "act": "refresh-thumbnail",
					 "width": coords.IMAGE_WIDTH,
					 "height": coords.IMAGE_HEIGHT
				}
				
				 jQuery.ajax({
						url: uri,
						data: refreshData,
						success: function(data) {
							//Do nothing in here
							//var myobj = JSON.parse(data);
						}
				});
	
			} else {
				jQuery('#save-drawing-title').html("Save");
				$('#tool-message').html("Save Error");
				alert("Sorry there was an error: " + JSON.stringify(myobj.error));
	
			}
		}	//End of success
	 });  //End of ajax call
}


group.saveTool = function (coords) {
	//AJ added.

	var polys = this.getAllAsJSON();
		
	if(verbose && verbose == true) {	
		alert("Saving polys:" + JSON.stringify(polys));
	} 	
		
	/* Creates e.g.	
	{
	"wound": {
		"type": "Feature",
		"properties": {},
		"geometry": {
			"type": "MultiPolygon",
			"coordinates": [
				[
					[
						[-2.175293, -1.45004],
						[-3.208008, -1.164471],
						[-3.295898, -1.120534],
						[-3.361816, -1.076597],
						[-3.581543, -0.703107],
						[-3.581543, -0.461421],
						[-3.55957, -0.35156],
						[-3.493652, -0.285643],
						[-3.427734, -0.263671],
						[-2.329102, -0.263671],
						[-2.15332, -0.219726],
						[-2.109375, -0.219726],
						[-1.713867, -0.944781],
						[-1.713867, -1.076597],
						[-1.757813, -1.296276],
						[-1.911621, -1.45004],
						[-2.175293, -1.45004]
					]
				],
				[
					[
						[-2.175293, -2.855263],
						[-2.241211, -2.833317],
						[-2.39502, -2.701635],
						[-2.460938, -2.635789],
						[-2.504883, -2.482133],
						[-2.504883, -2.438229],
						[-2.48291, -2.372369],
						[-2.39502, -2.262595],
						[-2.285156, -2.130856],
						[-2.175293, -2.043024],
						[-2.021484, -1.933227],
						[-1.713867, -1.801461],
						[-1.450195, -1.801461],
						[-1.40625, -1.823423],
						[-1.340332, -1.889306],
						[-1.318359, -1.933227],
						[-1.318359, -2.108899],
						[-1.340332, -2.394322],
						[-1.40625, -2.745531],
						[-1.428223, -2.855263],
						[-2.175293, -2.855263]
					]
				]
			]
		}
	},
	"sticker": {
		"type": "Feature",
		"properties": {},
		"geometry": {
			"type": "MultiPolygon",
			"coordinates": [
				[
					[
						[-2.329102, 0.153808],
						[-2.526855, 0.175781],
						[-2.834473, 0.263671],
						[-3.032227, 0.329588],
						[-3.186035, 0.417477],
						[-3.317871, 0.505365],
						[-3.515625, 0.79099],
						[-3.603516, 0.98872],
						[-3.603516, 1.054628],
						[-3.449707, 1.208406],
						[-3.339844, 1.274309],
						[-3.208008, 1.274309],
						[-2.8125, 1.537901],
						[-2.724609, 1.58183],
						[-2.658691, 1.58183],
						[-2.351074, 1.472006],
						[-2.307129, 1.45004],
						[-2.241211, 1.076597],
						[-2.087402, 0.747049],
						[-2.087402, 0.175781],
						[-2.109375, 0.153808],
						[-2.329102, 0.153808]
					]
				]
			]
		}
	}
}
					
		*/
		
	var styles = ["wound", "sticker", "negative", "under", "freestyle"];
	var myAreas = {
		"woundAreas" : [],
		"stickerAreas" : [],
		"underAreas" : [],
		"negativeAreas" : [],
		"freestyleAreas" : []
	};		
	
	
	
	for(var style = 0; style < styles.length; style++) {
		
		if(polys.hasOwnProperty(styles[style])) {
			
		
			var myStyle = polys[styles[style]];
			if(myStyle.geometry && myStyle.geometry.coordinates) {
				for(var cnt = 0; cnt< myStyle.geometry.coordinates.length; cnt++) {
					
					var points = [];
					if(styles[style] == "freestyle") {
						//A slightly different format, since it was not a polygon but a polyline
						var latLngs = myStyle.geometry.coordinates[cnt];
					} else {
						//A standard polygon
						var latLngs = myStyle.geometry.coordinates[cnt][0];
					}
					
					
					
					for(var coord = 0; coord < latLngs.length; coord++ ) {
						var thesePoints = group.convertLatLngToPixels(latLngs[coord][1], latLngs[coord][0], coords);
						if(Array.isArray(thesePoints)) {
							points.push(thesePoints);
						}
					}
					
					//Add a single poly
					var area = {};
					var area = {
						"type": styles[style],
						"status": "add",
						"handDrawing": true,
						"hideMidpoints": false,
						"areaSquarePixels": 0,
						"areaSquareCm": "[Unknown]",
						"midPointPixels": {
							"x": 0,
							"y": 0
						},
						"points": points
					};
					
					
					
					
					switch(styles[style]) {
						case "wound":
							myAreas.woundAreas.push(area);
						break;
	
						case "sticker":
							myAreas.stickerAreas.push(area);
						break;
	
						case "under":
							myAreas.underAreas.push(area);
						break;
	
						case "negative":
							myAreas.negativeAreas.push(area);
						break;
						
						case "freestyle":
							myAreas.freestyleAreas.push(area);
						break;
					}
					
				}	//End of loop through coordinates
				
			}	//End of if has coordinates
		} else { //End of if type exists 
		
		}
	}
	
	
	group.saveData(myAreas);				

};

group.clearPolygons = function () {
	this.eachLayer(function (layer) {
		
			
		if(activetype === layer.category) {
			if(activetype === "freestyle") {
				layer.clearLayers();
				
				//TODO: have this confirm
				/*if(confirm("Do you want to delete all freestyle drawings? 'Cancel' will remove your changes only.")) {
					layer.clearLayers();
					
					
				} else {
					//1. Save every layer but this
					//'false' is to not include the freestyle layer
					//group.saveTool(window.coords, false);
	
					
					//2. Refresh the page
					//window.location.reload(false);
					//return false;				
					layer.clearLayers();
					group.addSavedDrawings(savedAreas, window.coords);
					
				}*/
			
			} else {
				//Only delete this layer
				layer.clearLayers();
			}
		}
	});
};


group.convertPixelsToLatLng = function(x, y, coords)
{ 		
	var lng = (x / coords.ratioX) - coords.MAP_LNG_RANGE/2;
	var lat = (y / coords.ratioY) - coords.MAP_LAT_RANGE/2;

	return { "lat": lat, "lng": lng };
}


group.addSavedDrawings = function(areas, coords) {

	//TODO Note: this function is not used, but also not debugged.
	/*Saved areas = [{"type":"freestyle","status":"add","handDrawing":true,"hideMidpoints":false,"areaSquarePixels":16072.5,"areaSquareCm":0,"midPointPixels":{"x":0,"y":0},"points":[[422,552],[446,488],[445,426],[440,404],[436,401],[418,402],[399,400],[382,392],[368,399],[344,419],[332,440],[331,446],[334,507],[330,524],[330,533],[339,547],[351,558],[422,552]]}]
	*/	
		
	
	for(var cnt = 0; cnt < areas.length; cnt ++) {
		if(areas[cnt].type == "freestyle") {
			var json = {
			  "type": "FeatureCollection",
			  "features": [
			  ]
			};
		
			
			properties = {
				"stroke": "#502b62",
				"stroke-width": 2,
				"stroke-opacity": 0.35,
				"fill": "#888",
				"fill-opacity": 0.00,
				"name": "freestyle",
				"polygonFill": false
			  };
			  
			  myStyle = {
				color:'#EEE',
				fillOpacity : 0.00,
				noClip : true,
				clickable : false,
				smoothFactor : 0
			};
				
		
		
		
		
			if(areas[cnt].points) {

				var createPoly = [];
				for(var point = 0; point < areas[cnt].points.length; point++) {

					var latLng = group.convertPixelsToLatLng(areas[cnt].points[point][0], areas[cnt].points[point][1], coords);
					var lat = latLng.lat;
					var lng = latLng.lng;
					createPoly.push([lng, lat]);
				}
			}
		
			var newGeometry = {
		
				 "geometry": {
					"type": "MultiPolygon",
					"coordinates": [
					  [
						   createPoly
					  ]
					]
				  },
				  "type": "Feature",
				  "properties": properties
			  
			};
		
			json.features.push(newGeometry);
		
			if(areas[cnt].points) {

				var createPoly = [];
				for(var point = 0; point < areas[cnt].points.length; point++) {

					var latLng = group.convertPixelsToLatLng(areas[cnt].points[point][0], areas[cnt].points[point][1], coords);
					var lat = latLng.lat;
					var lng = latLng.lng;
					createPoly.push([lat, lng]);
				}
			}		

			//A line only
			var polygon = L.polyline(createPoly);
	
			polygon.loadedPolygons = true;
			polygon.setMode = function(newMode) {
				this.mode = newMode;
			};
			polygon.eachLayer = function() {};
			polygon.category = areas[cnt].type;
			polygon.setStyle(myStyle);
			

			this.eachLayer(function (layer) {			
				if(activetype === layer.category) {
					if(activetype === "freestyle") {
						layer.Polyline(polygon, {
								color: '#EEE',
								smoothFactor: 0
								},);

						//var group = layer.getGroup();
						//group.addPolygon(polygon, true, true, true);
					}
				}
			});
		
			//Include? window.polygons.push(polygon);
		}	//end of if freestyle layer
					
		
	}
	
}



group.handleToolAndType = function () {

	//AJ added:
	var display = {
		"add": "Draw",
		"subtract": "Subtract",
		"delete" : "Delete",
		"clear" : "Cleared",
		"wound" : "Wound",
		"sticker": "Sticker",
		"under" : "Undermining",
		"negative": "Islands",
		"pan": "Pan",
		"freestyle": "Freestyle"	
	}
	if((activetool === "pan")||(activetool === "clear")) {
		$('#tool-message').html(display[activetool]);
		
	} else {
		$('#tool-message').html(display[activetool] + " " + display[activetype]);
	}


	// make sure canvas is on top
	if (map._canvasCtx) {
		map._canvasCtx.canvas.style.zIndex = 1;
	}

	if (activetool === 'pan') {
		group.enablePanTool();

	} else if (activetool === 'add') {

		group.enableAddTool();

	} else if (activetool === 'subtract') {

		group.enableSubtractTool();
		
	} else if (activetool === 'delete') {
		// enable deletion of polygons in chosen land use type
		group.enableDeleteTool();

	} else if (activetool === 'clear') {
		// clear all shapes in each category and enable 'add' tool

		group.clearPolygons();
		setTimeout(function() {
			$('#draw-tools').find('input').eq(1).trigger('click');
		}, 1000);		//One second and we're back to add mode
		
		
	}
};

group.deactivate = function () {
	// destroy polygons
	this.clearPolygons();

	// reset tools
	$('#draw-tools').find('input').first().trigger('click');
	$('#draw-colors').find('input').first().trigger('click');
};

// handlers
// listen for add, subtract, delete, clear
$('#draw-tools').on('change', 'input', function () {
	activetool = this.value;
	group.handleToolAndType();
	

});

$('#draw-colors').on('click', 'input', function () {
	activetype = this.value;
	if(activetype == "save") {
		return;
	}
	group.handleToolAndType();
	
	//Now make add mode.
	$('#draw-tools').find('input').eq(1).trigger('click');
	

	
});

map.whenReady(function () {
	group.handleToolAndType();
});

// define for Node module pattern loaders, including Browserify
if (typeof module === 'object' && 
    typeof module.exports === 'object') {
    module.exports = group;
    module.exports.setToPan = function () {
    	$('#draw-tools').find('input').first().trigger('click');
    };
}
},{"./categories":1,"./leaflet-map":4,"./region":5}],4:[function(require,module,exports){
	//'//{s}.tile.openstreetmap.org/{z}/{x}/{y}.png'
	
	//AJ added:
	var MAP_LNG_RANGE = coords.MAP_LNG_RANGE;  
	var MAP_LAT_RANGE = coords.MAP_LAT_RANGE;   
	var IMAGE_WIDTH = coords.IMAGE_WIDTH;
	var IMAGE_HEIGHT = coords.IMAGE_HEIGHT;
	var CREATE = 15;
	var ratioX = coords.ratioX;
	var ratioY = coords.ratioY;
	var LAT_LNG=[0,0];
	var TILE_URL= globalImage;		//'http://images.wisegeek.com/skin-wound.jpg';
	
	var left = - MAP_LNG_RANGE/2;	
	var right = - left;
	var top = - MAP_LAT_RANGE/2;	
	var bottom = - top;
	var imageBounds = [[top, left], [bottom, right]];
	
	
	var baseURL = globalImage,

	base = L.imageOverlay(TILE_URL, imageBounds);
	
	//Load up the background image first
	var photo = new Image();
	map = L.map('mapid', {
				layers : [base],			//baseMaps[localStorage.baseMap || 'Open Street Map']
				zoom : 6,
				center : [0, 0],
				minZoom: 5,
				maxZoom: 13,
				maxBounds: [
					[-MAP_LAT_RANGE/2, -MAP_LNG_RANGE/2],
					[MAP_LAT_RANGE/2, MAP_LNG_RANGE/2]
				],
				attributionControl: false,
				zoomControl : false,
			});
	
	photo.onload = function() {
		base.addTo(map);  			//Now it should be cached - add it to the map proper
		
		
	};
	photo.src = TILE_URL;
	
	base.on("load", function() { 
		map.on('baselayerchange', function (layer) {
			localStorage.baseMap = layer.name || '';
		});

		L.control.zoom({
			position : 'bottomleft'
		}).addTo(map);
	});
	
	//See tip at https://stackoverflow.com/questions/50879981/using-bringtofront-to-style-leaflet-layers-that-are-not-in-a-layer-event-with
	setTimeout(() => {
  		base.bringToFront();
	}, 0);
	

// define for Node module pattern loaders, including Browserify
if (typeof module === 'object' && 
    typeof module.exports === 'object') {
    module.exports = map;
}
},{}],5:[function(require,module,exports){


var region = L.geoJson(null, {
	style : {
		color:'yellow',
		fillOpacity : 0,
		noClip : true,
		clickable : false,
		smoothFactor : 0
	}
});


function convertPixelsToLatLng(x, y, coords)
{ 		
	var lng = (x / coords.ratioX) - coords.MAP_LNG_RANGE/2;
	var lat = (y / coords.ratioY) - coords.MAP_LAT_RANGE/2;

	return { "lat": lat, "lng": lng };
}

function addSavedFeatures(areas, region, coords) {


	/*Saved areas = [{"type":"wound","status":"add","handDrawing":true,"hideMidpoints":false,"areaSquarePixels":16072.5,"areaSquareCm":0,"midPointPixels":{"x":0,"y":0},"points":[[422,552],[446,488],[445,426],[440,404],[436,401],[418,402],[399,400],[382,392],[368,399],[344,419],[332,440],[331,446],[334,507],[330,524],[330,533],[339,547],[351,558],[422,552]]}]
	*/	
	
	
	window.polygons = [];
	
	
	
	for(var cnt = 0; cnt < areas.length; cnt ++) {
		var json = {
		  "type": "FeatureCollection",
		  "features": [
		  ]
		};
		
		
		
	
		
		//Colours	  
		properties = {
					"stroke": "#50622b",
					"stroke-width": 2,
					"stroke-opacity": 0.35,
					"fill": "#b4cd8a",
					"fill-opacity": 0.45,
					"name": "wound",
					"polygonFill": true
				  };
		
		var myStyle = {
				color:'green',
				fillOpacity : 0,
				noClip : true,
				clickable : false,
				smoothFactor : 0
			};		  
		
		
		switch(areas[cnt].type) {
			case "wound":
				properties = {
					"stroke": "#cc3300",
					"stroke-width": 2,
					"stroke-opacity": 0.35,
					"fill": "#ff9999",
					"fill-opacity": 0.15,
					"name": "wound",
					"polygonFill": true
				  }		
				  
				  myStyle = {
					color:'#ff9999',
					fillOpacity : 0.15,
					noClip : true,
					clickable : false,
					smoothFactor : 0
				};	
			break;
				
			case "sticker":
				
			
				properties = {
					"stroke": "#50622b",
					"stroke-width": 2,
					"stroke-opacity": 0.35,
					"fill": "#b4cd8a",
					"fill-opacity": 0.45,
					"name": "sticker",
					"polygonFill": true
				  };
				  
				  myStyle = {
					color:'#b4cd8a',
					fillOpacity : 0.45,
					noClip : true,
					clickable : false,
					smoothFactor : 0
				};
			break;
			
			case "under": 
			
				properties = {
					"stroke": "#62502b",
					"stroke-width": 2,
					"stroke-opacity": 0.35,
					"fill": "#cdb48a",
					"fill-opacity": 0.45,
					"name": "under",
					"polygonFill": true
				  };
				  
				  myStyle = {
					color:'#cdb48a',
					fillOpacity : 0.45,
					noClip : true,
					clickable : false,
					smoothFactor : 0
				};
		
			
			
			break;
			
			case "negative":
			
				properties = {
					"stroke": "#502b62",
					"stroke-width": 2,
					"stroke-opacity": 0.35,
					"fill": "#b48acd",
					"fill-opacity": 0.45,
					"name": "negative",
					"polygonFill": true
				  };
				  
				  myStyle = {
					color:'#b48acd',
					fillOpacity : 0.45,
					noClip : true,
					clickable : false,
					smoothFactor : 0
				};
			
			break;	
			
			
			case "freestyle":
			
				properties = {
					"stroke": "#502b62",
					"stroke-width": 2,
					"stroke-opacity": 0.35,
					"fill": "#888",
					"fill-opacity": 0.00,
					"name": "freestyle",
					"polygonFill": false
				  };
				  
				  myStyle = {
					color:'#EEE',
					fillOpacity : 0.00,
					noClip : true,
					clickable : false,
					smoothFactor : 0
				};
			
			break;	
		
		};
		
		
		
		if(areas[cnt].points) {

			var createPoly = [];
			for(var point = 0; point < areas[cnt].points.length; point++) {

				var latLng = convertPixelsToLatLng(areas[cnt].points[point][0], areas[cnt].points[point][1], coords);
				var lat = latLng.lat;
				var lng = latLng.lng;
				createPoly.push([lng, lat]);
			}
		}
		
		var newGeometry = {
		
			 "geometry": {
				"type": "MultiPolygon",
				"coordinates": [
				  [
					   createPoly
				  ]
				]
			  },
			  "type": "Feature",
			  "properties": properties
			  
		};
		
		json.features.push(newGeometry);
		
		
			

		
		
		if(areas[cnt].points) {

			var createPoly = [];
			for(var point = 0; point < areas[cnt].points.length; point++) {

				var latLng = convertPixelsToLatLng(areas[cnt].points[point][0], areas[cnt].points[point][1], coords);
				var lat = latLng.lat;
				var lng = latLng.lng;
				createPoly.push([lat, lng]);
			}
		}		

		if(properties.polygonFill == true) {
			var polygon = L.polygon(createPoly);
		} else {
			//A line only
			var polygon = L.polyline(createPoly);
		}
		polygon.loadedPolygons = true;
		polygon.setMode = function(newMode) {
			this.mode = newMode;
		};
		polygon.eachLayer = function() {};
		polygon.category = areas[cnt].type;
		polygon.setStyle(myStyle);

		
		window.polygons.push(polygon);
					
		
	}
	
}

addSavedFeatures(savedAreas, region, coords);

// define for Node module pattern loaders, including Browserify
if (typeof module === 'object' && 
    typeof module.exports === 'object') {
    module.exports = region;
}
},{}],6:[function(require,module,exports){
var map = require('./leaflet-map'),
    controls = require('./controls'),
    drawcontroller = require('./draw-controller'),
    region = require('./region');

region.addTo(map);
region.on('add', function () {
	map.fitBounds(this.getBounds());
});

window.map = map;
window.drawcontroller = drawcontroller;
},{"./controls":2,"./draw-controller":3,"./leaflet-map":4,"./region":5}]},{},[6]);
